Max Sum Plus Plus HDU

来源:互联网 发布:android 应用启动优化 编辑:程序博客网 时间:2024/05/16 10:13

Now I think you have got an AC in Ignatius.L's "Max Sum" problem. To be a brave ACMer, we always challenge ourselves to more difficult problems. Now you are faced with a more difficult problem. 

Given a consecutive number sequence S 1, S 2, S 3, S 4 ... S x, ... S n (1 ≤ x ≤ n ≤ 1,000,000, -32768 ≤ S x ≤ 32767). We define a function sum(i, j) = S i + ... + Sj (1 ≤ i ≤ j ≤ n). 

Now given an integer m (m > 0), your task is to find m pairs of i and j which make sum(i 1, j 1) + sum(i 2, j 2) + sum(i 3, j 3) + ... + sum(i m, j m) maximal (i x ≤ i y≤ j x or i x ≤ j y ≤ j x is not allowed). 

But I`m lazy, I don't want to write a special-judge module, so you don't have to output m pairs of i and j, just output the maximal summation of sum(i x, j x)(1 ≤ x ≤ m) instead. ^_^ 
Input
Each test case will begin with two integers m and n, followed by n integers S 1, S 2, S 3 ... S n
Process to the end of file. 
Output
Output the maximal summation described above in one line. 
Sample Input
1 3 1 2 32 6 -1 4 -2 3 -2 3
Sample Output
68          
Hint
Huge input, scanf and dynamic programming is recommended.

题意:给你一个序列,让你求其中m段子段的最大和。

思路:1000000的n,我也是很无奈,看的kuangbin大神的解析,用滚动数组优化,不过之间的滚动数组的更新看了它的操作很是佩服。

以下是他的解析:

本题的大致意思为给定一个数组,求其分成m个不相交子段和最大值的问题。

Num为给定数组,n为数组中的元素总数,Status[i][j]表示前i个数在选取第i个数的前提下分成j段的最大值,其中1<=j<=i<=n && j<=m,状态转移方程为:

Status[i][j]=Max(Status[i-1][j]+Num[i],Max(Status[0][j-1]~Status[i-1][j-1])+Num[i])

乍看一下这个方程挺吓人的,因为题中n的限定范围为1~1,000,000m得限定范围没有给出,m只要稍微大一点就会爆内存。但仔细分析后就会发现Status[i][j]的求解只和Status[*][j]Status[*][j-1]有关所以本题只需要两个一维数组即可搞定状态转移。

在进行更进一步的分析还会发现其实Max(Status[0][j-1]~Status[i-1][j-1])根本不需要单独求取。在求取now_Status(保存本次状态的数组)的过程中即可对pre_Status(保存前一次状态的数组)进行同步更新。

 

 

状态dp[i][j]
有前j个数,组成i组的和的最大值。
决策: 第j个数,是在第包含在第i组里面,还是自己独立成组。
方程 dp[i][j]=Max(dp[i][j-1]+a[j] , max( dp[i-1][k] ) + a[j] ) 0<k<j
空间复杂度,m未知,n<=1000000,  继续滚动数组。
时间复杂度 n^3. n<=1000000.  显然会超时,继续优化。
max( dp[i-1][k] ) 就是上一组 0....j-1 的最大值。我们可以在每次计算dp[i][j]的时候记录下前j个
的最大值 用数组保存下来  下次计算的时候可以用,这样复杂度 变为 n^2.
上代码:


#include<cstdio>#include<iostream>#include<cstring>using namespace std;int a[1000010];int dp[1000010];int maxx[1000010];int main(){    int n,m;    while(scanf("%d%d",&n,&m) != EOF)    {        for(int i=1; i<=m; i++) scanf("%d",&a[i]);        memset(dp,0,sizeof(dp));        int maxn;        memset(maxx,0,sizeof(maxx));        for(int i=1; i<=n; i++)        {            maxn = -999999999;            for(int j=i; j<=m; j++)//这里从i开始,因为 i组 至少需要i个数            {               dp[j] = max(dp[j-1]+a[j],maxx[j-1]+a[j]);               maxx[j-1] = maxn;//已下是不断更新滚动数组,其实这个可以在草稿纸上画一画,反正我是这样搞明白的。               maxn = max(maxn, dp[j]);            }        }        cout << maxn << endl;    }    return 0;}

水波。